// This widget randomly selects one object out of all unlocked objects.
// All unlocked obbjects will be set to a low transparency (putting them in the lottery box)
// Each draw will set back the transparency to 1.0
// After a draw the item can be returned to the lottery box (transparency set back to 0.2) or not
// As an option, one can follow the link of a selected object (if it has one)


var lotteryElements = null;  // array of guids of objects that can be drawn / selected
var keepSelected = true;     // once drawn, the element is not returned to lottery box. -> no repeated selection of drawn elements
var followLink = false;      // follow the link of an object if it has one
var blockAnimation = false;  // avoid staringt the pickup animation multipe times



// put all unlocked elements into the lottery box (setup lotteryElements)
function setupLottery() {

    if (lotteryElements != null) return; // allready set.
    
     // get all objects that should be used in the lottery
    var allObjects = NB.page.getObjectsAsArray();    
    lotteryElements = new Array();        
    for (var i = 0; i < allObjects.length; ++i) {
    
       if ( allObjects[i].type != "widget"  && allObjects[i].lockType != "Lock In Place") {
        
        console.log ("Adding: " + allObjects[i]);
        lotteryElements.push(allObjects[i].guid);
        
       } // end if
                            
    } // end for
        
    
} // end function



// set all all lottery elements to a lower transparency
function fadeAllLotteryElements() {
    
    if (lotteryElements == null) return;
    
    NB.beginBatch();    
        for (var i = 0; i < lotteryElements.length; ++i) {                   
            obj = NB.getObject (lotteryElements[i]);            
            obj.transparency = 0.2;            
        }    
    NB.endBatch();
    
}


// Reset all elements to not drawn
function reset() {
    
    if (blockAnimation) return;
   
    lotteryElements = null;
    setupLottery();
    fadeAllLotteryElements();
    
}


// turns all lottery elements on / similar to having drawn all. links will not be followed
function resetON() {
   if (blockAnimation) return;
   
   for (var i = 0; i < lotteryElements.length ; ++i ) {
            obj = NB.getObject (lotteryElements[i]);            
            obj.transparency = 1.0;
   }
   
   lotteryElements == null;
   
}

// starts a lottery draw
function startDraw() {
  
   if (blockAnimation) return;
   blockAnimation = true;
   
   setButtonImage();
  
    setupLottery(); // in case it is not setup
    fadeAllLotteryElements();
    lotteryDraw();

    
}


// should drawn elements be repeated?
function switchKeepSelected() {
    
      keepSelected = !keepSelected; // switch      
      
      if (keepSelected)
       document.getElementById("noRepeatBox").src = "checked.png";
          else
      document.getElementById("noRepeatBox").src = "unchecked.png";
      

}

// should the link of the drawn object be invoked?
function switchFollowLink() {

      followLink = !followLink ; // switch          
      
      if (followLink)
       document.getElementById("followLinkBox").src = "checked.png";
          else
      document.getElementById("followLinkBox").src = "unchecked.png";      
      

}

// gui info
function setButtonImage() {
    
    if (blockAnimation)
       document.getElementById("startButton").src = "startRunning.png";
    else
       document.getElementById("startButton").src = "startButton.png";
    
}


///////////////////////////////////////////////// ANimation timer ///////////////////////////



// Animation stuff /

// Timer (from selfhtml):
Function.prototype.Timer = function (interval, calls, onend) {
  var count = 0;
  var payloadFunction = this;
  var startTime = new Date();
  var callbackFunction = function () {
    return payloadFunction(startTime, count);
  };
  var endFunction = function () {
    if (onend) {
      onend(startTime, count, calls);
    }
  };
  var timerFunction = function () {
    count++;
    if (count < calls && callbackFunction() != false) {
      window.setTimeout(timerFunction, interval);
    } else {
      endFunction();
    }
  };
  timerFunction();
};
// end code from self html


// duration of pickup animation
var numberOfSteps = 30;


// the drawing is done in numberOfSteps. Each step highlights an undrawn
// object and then turns it off again. 

function lotteryDraw () {
    
   console.log("Start drawing")


   var lastElementGUID = null; // remember the temporarily highlighted object
   var ticks = 0; // degug info

    
   var step = function() {		
	
        // debug info:
        ticks++;
        console.log ("tick " + ticks);
        

        // if a link should be invoked we stop the highlighting earlier to make sure
        // that the finally drawn element stays highlighted for some moments before
        // we jump to the linked page.
        if (followLink && ticks > numberOfSteps - 10) {
            console.log ("Sleep");   
        } else {

            // This is the process that turns on/off the highlighting of an object while drawing        
            console.log ("Last Element:" + lastElementGUID );
            
            // turn last highlighted object OFF
            if (lastElementGUID != null) {                
                lastElement = NB.getObject (lastElementGUID);
                lastElement.transparency = 0.2;                
            }
    
            
            // select one of the remaining elements of the lottery box by random:
            var randomNumber = Math.floor(Math.random() * lotteryElements.length);
            var nextElementGUID = lotteryElements[randomNumber];
            
            
            console.log (randomNumber + " means " + nextElementGUID); 
            
            // highlight the selected object and remember it to turn it off in the next animation step
            var nextElement = NB.getObject (nextElementGUID);
            nextElement.transparency = 1;            
            lastElementGUID = nextElementGUID;
        
        } // end if sleep or do
        
        
    
        
    }
    
    
    step.Timer ( 80  , numberOfSteps, function( ) {
        
            // This function is called when the animation is terminated.
            // The last highlighted object is the one that is drawn.
            
            console.log ("At the end.");
                        
            
            // If we keep the selected element  (no repeat) then
            // we need to take it out ouf the lottery box:
            if (keepSelected) {
                
                // as long as there are more objects, we can take the object out of the box
                if (lotteryElements.length > 1 ) {                    
                    // Make a new list of lotteryElements without the last drawn:
                    fewerLotteryElements = new Array();
                    for (var i = 0; i < lotteryElements.length; ++i) {
                        if ( lotteryElements [i] != lastElementGUID ) {
                            fewerLotteryElements.push (lotteryElements[i]);
                        }                        
                    }
                    
                    lotteryElements = fewerLotteryElements; // now make the smaller element list our lottery.                    
                    
                    
                } else {
                    
                    // if there was only one element left, then we have no more objects in the lottery box
                    lotteryElements = null; // That's it. The last item was drawn
                    
                } // end if number of remaining elements
                
            } // end if keepSelected
            
            
            // unblock animation:
            blockAnimation = false;
            setButtonImage();
            
            // Follow the link if the objectec is linked:
            console.log ("Follow link?" + followLink);
            if ( followLink ) {
                console.log ("follow to: " +  lastElementGUID);
                NB.page.invokeLink (lastElementGUID);
            }
        
        
        }) ;
    
}


