/* Long press gesture recognizer. Increases the time continuously while button is pressed. c*/

function LongPress(onInc) {
	this.timeoutId = null;
	this.onInc = onInc; // function(LongPress lp, Int btn) //called when time should be incremented.
	this.isFirst = 0;
	this.firstDelay = 500; //milliseconds
	this.additionalDelay = 100;
	this.btn = -1;
	this._isPastFirstDelay = false; //true if firstDelay has been reached and timer is now incrementing.
};

LongPress.prototype = {

	isPastFirstDelay: function() {
		return this._isPastFirstDelay;
	},

	mousedown: function(btn) {
		this.btn = btn;
		this.timeoutId = setTimeout(this.onTimeout.bind(this), this.firstDelay);
		this._isPastFirstDelay = false;
	},

	mouseup: function() {
		clearTimeout(this.timeoutId);
		this.timeoutId = null;
		this._isPastFirstDelay = false;
	},

	onTimeout: function() {
		this._isPastFirstDelay = true;
		if(this.onInc) {
			this.onInc(this, this.btn);
		}
		this.timeoutId = setTimeout(this.onTimeout.bind(this), this.additionalDelay);
	},

};
