function Wedge() {
	this.jq = $('<canvas/>') //Main Element
		.css({
			position: 'absolute',
		});
	this._outerBorderColor = 'transparent'
	this._outerBorderWidth = 0;
	this._spanDegrees = 0;
	this._rotationDegrees = 0;
};

Wedge.prototype = {

	//Rotation
	rotationDegree: function() {
		return this._rotationDegrees;
	},

	setRotationDegrees: function(degrees) {
		this._rotationDegrees = this.normalize(degrees);
		this.draw();
	},

	spanDegrees: function() {
		return this._spanDegrees;
	},

	setSpanDegrees: function(degrees) {
		if(degrees > 360 || degrees < 0) {
			degrees = this.normalize(degrees);
		}
		this._spanDegrees = degrees;
		this.draw();
	},

	normalize: function(angle) {
		angle = angle % 360;
		if(angle < 0) {
			angle += 360;
		}
		return angle;
	},

	//Border
	outerBorderWidth: function() {
		return this._outerBorderWidth;
	},

	setOuterBorderWidth: function(width) {
		this._outerBorderWidth = width;
		this.draw();
	},

	outerBorderColor: function() {
		return this._outerBorderColor;
	},

	setOuterBorderColor: function(color) {
		this._outerBorderColor = color,
		this.draw();
	},

	setOuterBorder: function(width, color) {
		this._outerBorderWidth = width;
		this._outerBorderColor = color;
		this.draw();
	},

	//Layout
	setCenter: function(x, y) { 
		var r = this.width() / 2;
		this.jq.css({
			left: x - r,
			top: y - r,
		});
	},

	radius: function() {
		return this.jq.width() / 2;
	},

	setRadius: function(r) {
		this.jq.css({
			width: 2 * r,
			height: 2 * r,
		});
		this.draw();
	},

	setWidth: function(w) {
		this.jq.css({
			width: w,
			height: w,
		});
		this.draw();
	},
	
	draw: function() {
		//Render with 2x definition
		var w = this.jq.width();
		var h = this.jq.height();
		this.jq.attr('width', (w * 2) + 'px')
			.attr('height', (h * 2) + 'px');
		var cnv = this.jq[0];
		var ctx = cnv.getContext('2d');
		var radius = w - this._outerBorderWidth;
		ctx.lineWidth = 2 * this._outerBorderWidth;
		ctx.strokeStyle = this._outerBorderColor;
		var start = this._rotationDegrees * Math.PI / 180;
		var end = start + this._spanDegrees * Math.PI / 180;
		ctx.beginPath();
		ctx.arc(w, h, radius, start, end);
		ctx.stroke();

	},

};
